
/* Project name:
     R2R DAC Example
 * Copyright:
     (c) Mikroelektronika, 2010.
  * Revision History:
     20101020:
       - 20101020 - Ranko Rankovic;
 * Description:
     This example makes samples of cosine and transfer it to R2R DAC which
     produces 50Hz signal
 * Test configuration:
     MCU:             AT89S8253
                      http://www.atmel.com/dyn/resources/prod_documents/doc3286.pdf
     dev.board:       http://www.mikroe.com/eng/products/view/329/easy8051-v6-development-system/
     Oscillator:      HS, 8.0000 MHz
     Ext. Modules:    R2R DAC Extra Board:
                      http://www.mikroe.com/eng/products/view/223/r2r-dac-board/
     SW:              mikroC PRO for 8051 v2.20
                      http://www.mikroe.com/en/compilers/mikroc/pro/pic/
 * NOTE:
     - Connect R2R DAC Board on Port1
*/


char sample;
char array[61];
char cnt;

void main() {

  cnt = 0;

  for (sample = 0; sample <= 60; sample++) {                  // 61 sample from 0 to pi
    array[sample] = (255l * (1000 + cosE3(cnt)))/2000;        // Making samples
    cnt = cnt + 3;                                            // 3*60=180
  }

  while(1) {

    for (sample = 0; sample <= 60; sample++) {                // Samples from 0 to pi
      P1 = array[sample];
      Delay_us(150);                                          // This delay is calculated in order to make the signal with 50Hz frequency
                                                              // This is the formula for calculating delay:
                                                              // Delay = 1/(Freq*133)
                                                              // For 50Hz  Delay is 1/(50*133) = 150us
    }

    for (sample = 59; sample > 0; sample--) {                 // Samples from pi to 2pi
      P1 = array[sample];
      Delay_us(150);
    }
  }
}
